import { y as defineEventHandler, b0 as useLogger, U as User, v as createError, E as Event } from '../../nitro/nitro.mjs';
import { b as requireUser } from '../../_/session.mjs';
import 'luxon';
import '@sequelize/core';
import 'html-to-text';
import 'zod';
import 'crypto';
import 'node:fs';
import 'sharp';
import 'path';
import 'node:stream';
import 'jsdom';
import 'dompurify';
import 'mime-types';
import 'fs';
import 'fs/promises';
import 'linkify-html';
import '@peertube/http-signature';
import 'jsonld';
import 'lodash.intersection';
import 'email-templates';
import 'node:http';
import 'node:https';
import 'node:crypto';
import 'node:events';
import 'node:buffer';
import 'node:path';
import 'vue';
import 'vue-router';
import 'dotenv';
import 'url';
import 'bcryptjs';
import 'slugify';
import 'umzug';
import 'consola';
import '@sequelize/core/decorators-legacy';
import 'util';
import 'mitt';
import 'ical.js';
import 'node:url';
import 'fast-xml-parser';
import '../../_/getUser.mjs';
import '../../_/jwt.mjs';
import 'jose';

const index_delete = defineEventHandler(async (event) => {
  const log = useLogger("user self delete");
  const user = await requireUser(event);
  const userInstance = await User.findByPk(user.id);
  if (!userInstance) {
    throw createError({ status: 404, message: "This user does not exists" });
  }
  log.info(`User ${user.id} (${user.email}) is deleting their own account`);
  try {
    await Event.update({ userId: void 0 }, { where: { userId: user.id } });
    return userInstance.destroy();
  } catch (e) {
    log.error("Error deleting user:", e);
    throw createError({ status: 500, message: "Error deleting user" });
  }
});

export { index_delete as default };
